#include "stdafx.h"
#include "Device.h"

Device::Device(int type, int id, VersionInfo version) {
	this->type = type;
	this->id = id;
	this->serialnum = version.serialnumber;
	this->module = version.module;
	this->version = version.version;
}
System::String ^Device::ToString() {
	switch (type) {
		case BOOTLOADER:return L"USB2LCD+ in Bootloader #"+id+L", v"+DISP_VERSION(version)+L", ID: "+serialnum.ToString(L"X4")+L")";
		case U2L_COM:	return L"USB2LCD+ (COM"+id+L", v"+DISP_VERSION(version)+L", ID: "+serialnum.ToString(L"X4")+L")";
		case COM_DEVICE:return L"Other (COM"+id+L")";
		default:		return L"Unknown ("+id+L")";
	}
}