#pragma once

#include "Device.h"

/**
The device chooser screen (the first window that comes up)
**/

namespace lcdsetter {
	public ref class DeviceChooser : public System::Windows::Forms::Form {
	public:
		Device ^device;
		DeviceChooser(void);
	protected:
		void RefreshList();
		union VersionInfo getVersion_com(int port);
	private:
		System::Windows::Forms::ComboBox^  combo;
		System::Windows::Forms::Button^  buttonRefresh;
		System::Windows::Forms::Button^  buttonSelect;
		void InitializeComponent(void);
		void buttonRefresh_Click(System::Object^ sender, System::EventArgs^ e);
		void buttonSelect_Click(System::Object^  sender, System::EventArgs^ e);
	};
}
