#pragma once

using namespace System;

/**
The progress bar dialog used during firmware updates.
**/

namespace lcdsetter {
	public ref class Dialog : public System::Windows::Forms::Form {
		delegate System::Windows::Forms::DialogResult ShowDialog$(System::Windows::Forms::IWin32Window ^);
		delegate void SetText$(String ^);
		delegate void SetInt$(int);
		delegate void SetBool$(bool);
		delegate void Close$();
		static Dialog ^d = nullptr;
		Dialog(String ^title, String ^message);
		System::Windows::Forms::DialogResult ShowDialog_(System::Windows::Forms::IWin32Window ^w);

	public:
		static void CreateForm();
		static System::Windows::Forms::DialogResult ShowModal(System::Windows::Forms::IWin32Window ^w, String ^title, String ^message);
		static void ShowNonModal(String ^title, String ^message);
		static void CloseForm();

		static void SetTitle(String ^title);
		static void SetText(String ^text);
		static void SetProgress(int progress);
		static void SetProgressMax(int max);
		static void SetProgressStyle(bool marquee);

	private: System::Windows::Forms::ProgressBar^  progressBar;
	private: System::Windows::Forms::Label^  label;
		void InitializeComponent(void);
	};
}

void __stdcall progress(int cur, int total);
wchar_t *toWCS(String ^s);