#include "StdAfx.h"
#include "LCDText.h"

using namespace lcdsetter;

LCDText::LCDText(void) : System::Windows::Forms::TextBox() {}
System::String ^LCDText::GetDisplayText(System::String ^text) {
	for (int i = 0; i < 32; i++)
		text = text->Replace(i, placeHolder);
	for (int i = 127; i < 257; i++)
		text = text->Replace(i, placeHolder);
	return text;
}
void LCDText::WndProc(System::Windows::Forms::Message %m) {
	if (m.Msg == 0x000C && ignore) { // WM_SETTEXT
		ignore = false;
	} else if (m.Msg == 0x000F) { // WM_PAINT
		System::String ^text = GetDisplayText(this->Text);
		System::String ^text_ = this->Text;
		if (text == text_) {
			System::Windows::Forms::TextBox::WndProc(m);
		} else {
			int selStart = this->SelectionStart;
			int selLen = this->SelectionLength;

			this->SuspendLayout();
			// set the text how we want it to show up
			this->Text = text;
			this->SelectionStart = selStart;
			this->SelectionLength = selLen;
			// let the paint message through
			System::Windows::Forms::TextBox::WndProc(m);
			// set the text back to how it should be, but ignore the next SETTEXT message
			ignore = true;
			this->Text = text_;
			this->SelectionStart = selStart;
			this->SelectionLength = selLen;
			this->ResumeLayout();
		}
	} else {
		System::Windows::Forms::TextBox::WndProc(m);
	}
}
