#pragma once

/*
The GPO editor
*/

namespace lcdsetter {
	public ref class EditGPOs : public System::Windows::Forms::Form {
		static EditGPOs ^form = nullptr;
		static bool isU2L = isU2L;
		static System::String ^port;
		static int baud = 0;
	public:
		static void OpenForm(bool isU2L, System::String ^port, int baud);
		static void CloseForm();
	protected:
		EditGPOs(void);
	private: System::Windows::Forms::Button^  butReadCur;
	private: System::Windows::Forms::Button^  butReadMem;
	private: System::Windows::Forms::Button^  butSetMem;
	private: System::Windows::Forms::Button^  butSetCur;
	private: System::Windows::Forms::RadioButton^  radioOn1;
	private: System::Windows::Forms::GroupBox^  groupGPO1;
	private: System::Windows::Forms::RadioButton^  radioOff1;
	private: System::Windows::Forms::TrackBar^  trackBar1;
	private: System::Windows::Forms::Label^  label1;
	private: System::Windows::Forms::GroupBox^  groupGPO2;
	private: System::Windows::Forms::Label^  label2;
	private: System::Windows::Forms::TrackBar^  trackBar2;
	private: System::Windows::Forms::RadioButton^  radioOff2;
	private: System::Windows::Forms::RadioButton^  radioOn2;
	private: System::Windows::Forms::GroupBox^  groupGPO3;
	private: System::Windows::Forms::Label^  label3;
	private: System::Windows::Forms::TrackBar^  trackBar3;
	private: System::Windows::Forms::RadioButton^  radioOff3;
	private: System::Windows::Forms::RadioButton^  radioOn3;
	private: System::Windows::Forms::GroupBox^  groupGPO4;
	private: System::Windows::Forms::Label^  label4;
	private: System::Windows::Forms::TrackBar^  trackBar4;
	private: System::Windows::Forms::RadioButton^  radioOff4;
	private: System::Windows::Forms::RadioButton^  radioOn4;
	private: System::Windows::Forms::GroupBox^  groupGPO5;
	private: System::Windows::Forms::Label^  label5;
	private: System::Windows::Forms::TrackBar^  trackBar5;
	private: System::Windows::Forms::RadioButton^  radioOff5;
	private: System::Windows::Forms::RadioButton^  radioOn5;
	private: void InitializeComponent();
private:void trackBar1_Scroll(System::Object^  sender, System::EventArgs^  e);
private:void trackBar2_Scroll(System::Object^  sender, System::EventArgs^  e);
private:void trackBar3_Scroll(System::Object^  sender, System::EventArgs^  e);
private:void trackBar4_Scroll(System::Object^  sender, System::EventArgs^  e);
private:void trackBar5_Scroll(System::Object^  sender, System::EventArgs^  e);
private:void butReadCur_Click(System::Object^  sender, System::EventArgs^  e);
private:void butReadMem_Click(System::Object^  sender, System::EventArgs^  e);
private:void butSetCur_Click(System::Object^  sender, System::EventArgs^  e);
private:void butSetMem_Click(System::Object^  sender, System::EventArgs^  e);
};
}