#pragma once

/**
A new text box class that shows all those boxes instead of weird characters
This is done through some trickery with the windows messages 
**/

namespace lcdsetter {
	public ref class LCDText : public System::Windows::Forms::TextBox
	{
		static const wchar_t placeHolder = L'\u2588'; // the box character
		bool ignore; // should we ignore the next windows message?
		public:LCDText(void);
		public:static System::String ^GetDisplayText(System::String ^text); // convert text to use boxes
		virtual void WndProc(System::Windows::Forms::Message %m) override;
	};
}
